/* Program take.cc      */
/* By Harald Stauss     */
/* Last change 25.08.98 */

#include <ctype.h>
#include <math.h>
#include "tsa.h"
#include "nrc/nrutil.h" 
#include "nrc/nrutil.c"
#include "nrc/four1.c"
#include "nrc/moment.c"

main(int argc, char *argv[])
{
           short    i, j;
  unsigned long     navg, n, m;
           float    sum;
           char     *fin, *ftin, *fpin, *fptin;
           char     *fout,*ftout,*fpout,*fptout;
           REGIST   r,f;
           ofstream ausdat;

  /* H e l l o   w o r l d */
  cout << "TAKE Ver. 1.1 by H. Stauss, 1998 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin=(char *)malloc(255);
  ftin=(char *)malloc(255);
  fout=(char *)malloc(255);
  ftout=(char *)malloc(255);

  /* P a r a m e t e r   e i n l e s e n */
  if (argc != 4)
    {
      cout << "Number of parameters wrong! \n";
      cout << "take f_in f_out n_avg \n";
      cout << "writes the first value in each channel \n";
      cout << "then, repeatedly averages n_avg values  \n";
      cout << "and writes them on the output file f_out. \n";
      cout << "f_in  : name of input file (*.TSA, *.ASC). \n";
      cout << "f_out : name of output file (*.TSA, *.ASC). \n";
      goto ende;
    }

  strcpy(fin,argv[1]);  fpin=fin;
  fptin=strrchr(fpin,'.');
  strcpy(fout,argv[2]); fpout=fout;
  fptout=strrchr(fpout,'.');

  strcpy(ftin,fptin); fptin=ftin; 
  for (i=0; fptin[i]; i++) fptin[i]=toupper(fptin[i]);
  strcpy(ftout,fptout); fptout=ftout; 
  for (i=0; fptout[i]; i++) fptout[i]=toupper(fptout[i]);

  sscanf(argv[3],"%d",&navg);

  cout << "Input file        : " << fin << "\n";
  cout << "Output file       : " << fout << "\n";

  /* E i n g a b e d a t e i   o e f f n e n */
  if (strcmp(fptin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(fptin,".ASC")==0) r.ReadASCII(fin,1);
  if ((strcmp(fptin,".TSA")!=0) && (strcmp(fptin,".ASC")!=0)) {
    cout << "File type for input not recognized! \n";
    goto ende;
  }
  cout << "Number of channels: " << r.n << "\n";

  /* A u s g a b e d a t e i   o e f f n e n   */
  for (i=0; i<r.n; i++) {
    f.AddChannel((unsigned long)(r.ch[i].n/navg)+1, 
		 r.ch[i].sr, 0, 1, 0, 0,
		 r.ch[i].name, r.ch[i].unit);
  }

  /* M A I N L O O P  */
  for (i=0; i<r.n; i++)  f.ch[i].data[0]=r.ch[i].data[0];
  for (i=0; i<r.n; i++) {
    m=1;
    for (n=1; n<r.ch[i].n; n+=navg) {
      if ((n+navg-1)<r.ch[i].n) {
	sum=0;
	for (j=0; j<navg; j++) sum+=r.ch[i].data[n+j];
	f.ch[i].data[m]=sum/navg;
	m++;
      }
    }
    f.ch[i].n=m;
  } /* endfor */

  /*   
A u s g a b e d a t e i   s c h r e i b e n   */
  if (strcmp(fptout,".TSA")==0) f.WriteTSA(fout);
  if (strcmp(fptout,".ASC")==0) f.WriteASCII(fout);
  if ((strcmp(fptout,".TSA")!=0) && (strcmp(fptout,".ASC")!=0)) {
    printf("File type for output not recognized! \n");
    goto ende;
  }

 ende:
  free(fin);free(ftin);free(fout);free(ftout);
  return(0);
} /* Ende von main */
